import asyncio
import logging
import random
import re
from datetime import datetime

from clockblocker_bot.config import config
from clockblocker_bot.utils.decorators import (
    beware_the_croud_policy,
    clean_up_policy,
    ignore_clockblocker,
    ignore_s3rius,
    mark_unread,
)
from telethon import events

logger = logging.getLogger(__name__)


@config.telegram_client.on(events.NewMessage(pattern="^.h$"))
@mark_unread
@beware_the_croud_policy
@clean_up_policy
async def show_help(event: events.NewMessage.Event):
    with open("./static_messages/help.txt") as f:
        contents = f.read()
    return await event.respond(contents)


@config.telegram_client.on(
    events.NewMessage(pattern=r"\W*[пП]+\s*[рР]+\s*[иИ]+\s*[вВ]+\s*[Ее]+\s*[тТ]+\W*")
)
@ignore_clockblocker
@beware_the_croud_policy
@mark_unread
@clean_up_policy
async def ci(event: events.NewMessage.Event):
    return await event.respond("Как дела?")


@config.telegram_client.on(
    events.NewMessage(
        pattern=re.compile(".*[Бб]ялдь.*", flags=re.DOTALL | re.MULTILINE),
        outgoing=True,
    )
)
@mark_unread
async def blyad(event: events.NewMessage.Event):
    permutations = set(["Блядь", "БлasDь", "лябдь", ",zklm", "блядь", "бляьд", "Бляьд"])
    start_time = datetime.now()
    current_time = start_time
    last_blyad = event.message.message
    while (current_time - start_time).seconds < 10:
        last_blyad = random.choice(list(permutations - set(last_blyad)))
        await event.message.edit(last_blyad)
        await asyncio.sleep(1)
        current_time = datetime.now()


@config.telegram_client.on(events.NewMessage(pattern=r".*сломал(ось|ись|ась|ся).*"))
@beware_the_croud_policy
@mark_unread
@clean_up_policy
async def reboot_advice(event: events.NewMessage.Event):
    return await event.respond("Стоит попробовать выключить и включить")


@config.telegram_client.on(events.NewMessage(pattern=r"[\)\s]+"))
@ignore_s3rius
@ignore_clockblocker
@clean_up_policy
@mark_unread
async def smile_back(event: events.NewMessage.Event):
    return await event.respond(event.message.message)
